(function(){
var _verbose = false;

var c2Runtime;

var step = -1;
var started = false;
var audioBuffer = [];
var timerUpdate;


var listOfAllSong = ["321_1.ogg","321_2.ogg","321_fight.ogg","brutality_phase_1.ogg","brutality_phase_2.ogg","butt_level.ogg","butt_menu.ogg","faux.ogg","fight_boss_die.ogg","fight_enemy_hit1.ogg","fight_enemy_hit2.ogg","fight_enemy_hit3.ogg","fight_enemy_hit4.ogg","fight_enemy_hit5.ogg","fight_enemy_hit6.ogg","fight_hammer1.ogg","fight_hammer2.ogg","fight_punch1.ogg","fight_punch2.ogg","fight_punch3.ogg","fight_punch4.ogg","fight_punch5.ogg","fight_punch_boss1.ogg","fight_punch_boss2.ogg","fight_sprotch.ogg","fight_the_boss_1.ogg","fight_the_boss_2.ogg","fight_weapon_broke.ogg","fight_woosh1.ogg","fight_woosh2.ogg","fight_woosh3.ogg","gameover_healthbarup.ogg","jackpot.ogg","laserchainsawhit.ogg","laserchainsawloop.ogg","lasersaber_hit_1.ogg","lasersaber_hit_2.ogg","lasersaber_hit_3.ogg","lasersaber_hit_4.ogg","lasersaber_pick.ogg","lasersaber_woosh_1.ogg","lasersaber_woosh_2.ogg","lasersaber_woosh_3.ogg","lasersaber_woosh_4.ogg","music_critical.ogg","music_ingame.ogg","music_menu.ogg","mysteriousweapon_boum.ogg","newrecord.ogg","phoenix.ogg","player_attack_perfect.ogg","player_die.ogg","player_hit1.ogg","player_hit2.ogg","player_throw_grenade.ogg","player_throw_grenade_explosion.ogg","player_ya1.ogg","player_ya10.ogg","player_ya11.ogg","player_ya2.ogg","player_ya3.ogg","player_ya4.ogg","player_ya5.ogg","player_ya6.ogg","player_ya7.ogg","player_ya8.ogg","player_ya9.ogg","revivalepicburstinyourface.ogg","roulette_slot.ogg","roulette_tone_1.ogg","roulette_tone_2.ogg","roulette_tone_3.ogg","swordscrape.ogg","victorytoolcoin.ogg","victory_coin.ogg","victory_game_over.ogg","victory_star.ogg","victory_win.ogg","wolfhit.ogg","wolfmode.ogg","wolfshoot.ogg","wrong.ogg"];
var category_list = [];

fillArrayCategory();

eventToFire.registerEvent("c2LayoutChange",
	function (args){
		if(!started){
			c2Runtime = cr_getC2Runtime();
			started = true;
			nextStep();
		}
	}
);

function update(){
	for (var i = 0; i < audioBuffer.length; i++) {
		if(audioBuffer[i].isLoadedAndDecoded()){ //audioBuffer[i].isLoaded()
			if(_verbose) console.log("sound end load & decoded:",audioBuffer[i].src);
			audioBuffer.splice(i, 1);
		}
	};

	if(audioBuffer.length == 0){
		nextStep();
	}
}

function nextStep(){
	step +=1;
	clearInterval(timerUpdate);

	if(category_list[step]){
		for (var i = category_list[step].length - 1; i >= 0; i--) {
			if(_verbose) console.log("sound start load:",category_list[step][i]);
			audioBuffer.push(c2Runtime.audioInstance.getAudioBuffer(c2Runtime.files_subfolder+category_list[step][i]));
		};

		timerUpdate = setInterval(update,100);

	}else{
		if(_verbose) console.log("all Sound loaded & decoded");
	}
}

function fillArrayCategory(){
	var firstLoad = [];
	var arrayWihtoutMusic = [];
	var musicInGame = [];
	var musicGameOver = [];
	var name;

	for (var i = 0; i < listOfAllSong.length; i++) {
		name = listOfAllSong[i].replace(/\.[a-z]+/,"");
		
		if(name == "butt_level" || name == "butt_menu" || name == "music_menu"){
			firstLoad.push(listOfAllSong[i]);
		}
		else if(name == "music_ingame"){
			musicInGame.push(listOfAllSong[i]);
		}
		//list of gameOverSong
		else if(name == "music_game_over" || name == "defeat_sound" || name == "defeat" || name == "victory_game_over" || name == "looser" || name == "gameOver_defeat" || name == "gameOver"){
			musicGameOver.push(listOfAllSong[i]);
		}
		else {
			arrayWihtoutMusic.push(listOfAllSong[i]);
		}
	};
	category_list.push(firstLoad);
	category_list.push(arrayWihtoutMusic);
	category_list.push(musicInGame);
	category_list.push(musicGameOver);
}

}())

